> For the complete documentation index, see [llms.txt](https://docs.chainrpc.io/chainrpc/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.chainrpc.io/chainrpc/networks/ethereum/json-rpc-methods/filter-methods/eth_newfilter.md).

# eth\_newFilter

Creates a filter object, based on filter options, to notify when the state changes (logs). To check if the state has changed, call [eth\_getFilterChanges](/chainrpc/networks/ethereum/json-rpc-methods/filter-methods/eth_getfilterchanges.md)

#### REQUEST PAYLOAD

* `FILTER OBJECT`
  * `address` *\[optional]* - a contract address or a list of addresses from which logs should originate.
  * `fromBlock` *\[optional, default is "latest"]* - hexadecimal block number, or the string "latest", "earliest" or "pending"
  * `toBlock` *\[optional, default is "latest"]* - hexadecimal block number, or the string "latest", "earliest" or "pending"
  * `topics`*\[optional]* - Array of 32 Bytes DATA topics. Topics are order-dependent.

**A note on specifying topic filters:** Topics are order-dependent. A transaction with a log with topics \[A, B] will be matched by the following topic filters:

* \[] - anything"
* \[A] - A in first position (and anything after)
* \[null, B] - anything in first position AND B in second position (and anything after)
* \[A, B] - A in first position AND B in second position (and anything after)"
* \[\[A, B], \[A, B]] - (A OR B) in first position AND (A OR B) in second position (and anything after)

Filter IDs will be valid for up to fifteen minutes, and can polled by any connection using the same v3 project ID.

#### EXAMPLE

```bash
## JSON-RPC over HTTPS POST
## Replace YOUR-API-KEY with an API key from your chainRPC Dashboard
## You can also replace mainnet with a different supported network
curl https://eth.chainrpc.io/v3/YOUR-API-KEY \
    -X POST \
    -H "Content-Type: application/json" \
    -d '{"jsonrpc":"2.0","method":"eth_newFilter","params":[{"topics": ["0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef"]}],"id":1}'

## JSON-RPC over WSS
## Replace YOUR-API-KEY with an API key from your chainRPC Dashboard
## You can also replace mainnet with a different supported network
wscat -c wss://eth.chainrpc.io/v3/YOUR-API-KEY
>{"jsonrpc":"2.0","method":"eth_newFilter","params":[{"topics": ["0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef"]}],"id":1}
```

### RESPONSE

#### RESULT FIELDS

* `FILTER ID` - A string denoting the newly created filter id

#### BODY

```json
{
    "jsonrpc":"2.0",
    "id":1,
    "result":"0x10ff0bfba9472c87932c56632eef8f5cc70910e8e71d"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.chainrpc.io/chainrpc/networks/ethereum/json-rpc-methods/filter-methods/eth_newfilter.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
